library ieee;

use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

package binRR4_pckg is
  component binRR4 is

    port(
	 B: in STD_LOGIC_VECTOR(7 downto 0);

	 Rs: out STD_LOGIC_VECTOR(3 downto 0);
	 R1: out STD_LOGIC_VECTOR(3 downto 0);
	 R0: out STD_LOGIC_VECTOR(3 downto 0) 
	);

  end component;
end package binRR4_pckg;


library ieee;

use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity binRR4 is

    port(
	 B: in STD_LOGIC_VECTOR(7 downto 0);

	 Rs: out STD_LOGIC_VECTOR(3 downto 0);
	 R1: out STD_LOGIC_VECTOR(3 downto 0);
	 R0: out STD_LOGIC_VECTOR(3 downto 0) 
	);

end entity binRR4;


architecture behav of binRR4 is

    signal M,N,P,Q,R: std_logic_vector(3 downto 0);

    begin

    process(M,N,P,Q,R)

    
    begin

        for i in 0 to 3 loop 

		
		M(i)<= (B(2*i) xor B(7)) and (B((2*i)+1) xor B(7));
	
       	 	N(i)<= M(i) and B(7);

		P(i)<= N(i) or (not (N(i)) and B(7));

		Q(i)<= (not N(i)) and (B(2*i+1) xor B(7));

		R(i)<= N(i) or ((not (N(i))) and (B(2*i) xor B(7)));

       end loop;


       for i in 0 to 3 loop
	
		
		if i =0 then  -- for the 1st RR4 digit

		Rs(i)<= (P(i) and Q(i)) or (P(i) and (not Q(i)) and (not B(7)));

		R1(i)<= (P(i) and (not R(i)) and (not B(7))) or (P(i) and Q(i) and R(i));

		R0(i)<= (P(i) and (not R(i)) and B(7)) or (R(i) and (not B(7)));
	
		
		else               -- for other RR4 digits

		Rs(i)<= (P(i) and Q(i)) or (P(i) and (not Q(i)) and (not N(i-1)));

		R1(i)<= (P(i) and (not R(i)) and (not N(i-1))) or (P(i) and Q(i) and R(i));

		R0(i)<= (P(i) and (not R(i)) and N(i-1)) or (R(i) and (not N(i-1)));

		
		end if;


      end loop;

    end process;

end architecture behav;

