library ieee;

use ieee.std_logic_1164.all; 
use ieee.numeric_std.all;

package decod_pckg is
    component decoder is

	port(
		IR: in bit_vector(7 downto 0);  -- Instruction Register
     		enable: in bit;

     		y0,y1,y2,y3,y4,y5,y6,y7: out bit

	);
    end component decoder;
end package decod_pckg; 


library ieee;

use ieee.std_logic_1164.all; 
use ieee.numeric_std.all;

entity decoder is
	port(
		IR: in bit_vector(7 downto 0);  -- Instruction Register
     		enable : in bit;
     		y0,y1,y2,y3,y4,y5,y6,y7: out bit
	);

end entity decoder;

architecture functional of decoder is

begin

	y0<=(not IR(7)) and (not IR(6)) and (not IR(5)); --for addition
	y1<=(not IR(7)) and (not IR(6)) and (IR(5)); --for subtraction
	y2<=(not IR(7)) and (IR(6)) and (not IR(5)); --for multiplication
	y3<=(not IR(7)) and (IR(6)) and (IR(5)); --for complementation 
	y4<=(IR(7)) and (not IR(6)) and (not IR(5)); --for Logical AND 
 	y5<=(IR(7)) and (not IR(6)) and (IR(5)); --for Logical OR 
	y6<=(IR(7)) and (IR(6)) and (not IR(5)); --for Logical NOT
	y7<=(IR(7)) and (IR(6)) and (IR(5)); --for Logical XOR

end architecture;


