-- Partial Product Module

library ieee;

use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

package parpro_pckg is
     component partial_product is

	port(

		Sa, a0, a1: in bit;  -- RR4 intermediate digit
		Sb, b0, b1: in bit;  -- RR4 intermediate digit

		Sc, c0, c1: in bit   -- RR4 partial product

	);
     end component partial_product;
end parpro_pckg;

library ieee;


use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity partial_product is

	port(

		Sa, a0, a1: in bit;  -- RR4 intermediate digit
		Sb, b0, b1: in bit;  -- RR4 intermediate digit

		Sc, c0, c1: out bit   -- RR4 partial product

	);
	
end entity partial_product;

architecture behav of partial_product is

begin

	
	Sc<= (Sa and Sb) or (Sa and (not b0) and (not b1)) or (Sb and (not a0) and (not a1)) or ((not Sa) and Sb and (not a0) and b0) or (Sa and (not Sb) and b0 and (not b0)) or ((not Sa) and Sb and b0 and b1) or (Sa and (not Sb) and a0 and a1);

	c0<= ((not a0) and (not a1) and b0) or (a0 and (not b0) and (not b1)) or ((not a0) and b0 and b1) or (a0 and a1 and (not b0));

        c1<= a1 xor b1;


end architecture behav;
