library ieee;

use ieee.std_logic_1164.all;
use ieee.numeric_std.all;


package multiplier_pckg is
     component RR4_multiplier is

	port(

		Scp: inout bit;		        -- sign of the previous carry digit
		
		S1, B1, A1: in bit;     -- 1st RR4 digit to be multiplied
		S2, B2, A2: in bit;     -- 2nd RR4 digit to be multiplied

		Sd1, d12, d11: out bit; -- intermediate sum digit
		Sd2, d22, d21: out bit -- intermediate carry digit

	);
     end component RR4_multiplier;
end multiplier_pckg;


library ieee;

use ieee.std_logic_1164.all;
use ieee.numeric_std.all;

entity RR4_multiplier is

	port(

		Scp: inout bit;		        -- sign of the previous carry digit
		
		S1, B1, A1: in bit;     -- 1st RR4 digit to be multiplied
		S2, B2, A2: in bit;     -- 2nd RR4 digit to be multiplied

		Sd1, d12, d11: out bit; -- intermediate sum digit
		Sd2, d22, d21: out bit -- intermediate carry digit
		
	);
	
end entity RR4_multiplier;

architecture behav of RR4_multiplier is

begin

------------------------------RR4 INTERMEDIATE CARRY DIGIT---------------------------------------

	Sd2<=S1 xor S2; 

	d22<=(B1 and B2 and A1 and A2)  or  (B1 and B2 and (A1 xor A2) and (not (S1 xor S2 
	xor Scp)));			

	d21<=(((B2 and (not A2)) or (B1 and (not A1))) and (not (S2 xor S1 xor Scp)) and (not 
	((B2 and A2) or (B1 and A1)))) or ((S1 xor S2 xor Scp) and ((B2 and A2) or (B1 and 
	A1))) or (A1 and A2 and (B1 xor B2)) or (B2 and (not A2) and B1 and (not A1));



---------------------------RR4 INTERMEDIATE SUM DIGIT--------------------------------------------


	Sd1<=(S1 xor S2) or (((B2 and (not A2)) or (B1 and (not A1))) and (not (S1 xor S2 xor 
	Scp))) or (A1 and A2 and (B1 xor B2));

	d12<=(A2 and B1 and (not A1)) or (B2 and (not A2) and A1);
 
	d11<=A1 and A2;

	

end architecture behav;
				
